您的位置:首页 > 其它

最大上升子序列的和

2017-08-08 10:50 190 查看


E - Super Jumping! Jumping! Jumping!

 

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now. 



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In
the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping
can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his
jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. 

Your task is to output the maximum value according to the given chessmen list. 

InputInput contains multiple test cases. Each test case is described in a line as follow:

N value_1 value_2 …value_N 

It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. 

A test case starting with 0 terminates the input and this test case is not to be processed. 

OutputFor each case, print the maximum according to rules, and one line one case. 

Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0


Sample Output
4
10
3


这样写是错的,因为没有考虑到序列可能为负

#include<cstdio>
#include<vector>
#include<algorithm>
using namespace std;
#define maxx 1000+10
int a[maxx],b[maxx];
int main()
{
int n,sum2;
int Max=0;

while(~scanf("%d",&n)&&n!=0)
{
int sum1=0;
for(int i = 0 ; i < n ; i++)
scanf("%d",&a[i]);
for(int i = 0 ; i < n ; i++)
b[i]=a[i];
for(int i = 1 ; i < n ; i++)
{
if(a[0]==a[1])
sum1=a[0];
if(a[i]>a[i-1]&&(a[i-1]>0))
{
b[i]+=b[i-1];
sum2=b[i];
}
Max=max(sum2,b[i]);
Max=max(Max,sum1);
}
sum1=sum2=0;
printf("%d\n",Max);
}
return 0;
}
正确算法:
实际上含负数的最大子序列和就是输出最小的负数

#include<cstdio>
#include<cstring>
#include<map>
#include<algorithm>
using namespace std;
#define INF 0x3f3f3f3f
//max,min,swap,unique
//dp[i]:以i结尾的数字可构成的最大和

// dp[i] = max(num[i] , dp[j:(1~i-1)] + num[i]) num[i] > num[j]

int num[1000+5];
int dp[1005]; //表示以i结尾的子串的最大和

int main()
{
int n;
while (~scanf ("%d",&n) && n)
{
for (int i = 1 ; i <= n ; i++)
scanf ("%d",&num[i]);

int ans = -INF;
for (int i = 1 ; i <= n ; i++)
{
dp[i] = num[i];
for (int j = 1 ; j < i ; j++)
{
if (num[i] > num[j])
dp[i] = max(dp[i] , dp[j] + num[i]);
ans = max(ans , dp[i]);
}
}
printf ("%d\n",ans);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: